<script lang="ts">
import { defineComponent, ComponentPublicInstance } from 'vue';
import JText from '@new-jira-clone/ui/src/components/shared/JText';

export default defineComponent({
  name: 'JDialogConfirm',
  components: {
    JText,
  },
  setup() {
    const setFocus = (element: HTMLElement | ComponentPublicInstance): void => {
      setTimeout(() => {
        if (!element) return;

        if ('$el' in element) {
          element.$el.focus();
        } else if ('focus' in element) {
          element.focus();
        }
      }, 100);
    };

    return {
      setFocus,
    };
  },
});
</script>

<template>
  <div class="j-dialog-confirm">
    <JText
      tag="div"
      weight="normal"
      color="secondary-title"
      type="title-4"
      class="j-dialog-confirm-title"
    >
      <slot name="title" />
    </JText>
    <JText
      tag="div"
      weight="normal"
      type="text-1"
      color="secondary-title"
      class="j-dialog-confirm-body"
    >
      <slot name="body" />
    </JText>
    <div class="j-dialog-confirm-actions">
      <slot name="actions" :set-focus="setFocus" />
    </div>
  </div>
</template>

<style lang="scss" scoped>
.j-dialog-confirm {
  display: flex;
  flex-direction: column;
  max-width: 552px;
}

.j-dialog-confirm-title {
  margin-bottom: 16px;
}

.j-dialog-confirm-body {
  margin-bottom: 32px;
}

.j-dialog-confirm-actions {
  display: flex;
  margin-left: auto;
}
</style>
